
; Impulsy:        110 ms < "0" < 165 ms
;                 220 ms < "1" < 275 ms

; -----------------------------------------------------------------------------
; Stanice slyiteln v Evrop:
; ---------------------------
;  DCF77 - Mainfligen (SRN)
;  HBG - Prangins (vcarsko)
;  MSF - Rugby (Velk Britnie)
;  OMA - Liblice (R) (viz AR 1976 a 1979)
;
; Vysla DCF je umstn v Mainfligenu pobl Frankfurtu nad Mohanem (SRN).
; Vysla vysl na kmitotu 77.5 kHz a m vkon 27 kW. Nepesnost daje
; je 2 * 10^-13 za 100 dn. Sekundov znaka je vytvoena zmenenm amplitudy
; nosn na 25 % na zatku kad sekundy. Dlka sekundov znaky je bu 100 ms
; (="0") nebo 200 ms (="1"). Bhem kad minuty je odvyslna pln asov
; informace mezi 20. a 58. sekundou - tj. stedoevropsk as, platn pro
; nsledujc minutu souasn s datem. Zatek penosu zan ve 20. sekund
; kad minuty odvyslnm sekundov znaky "1". Vechny daje jsou peneny
; v BCD kdu (od nejnich bit a od nejnich slic). daje minut jsou
; odvyslny mezi 21. a 27. sekundou (4 + 3 bity). V 28. sekund je vysln
; paritn bit pro minuty (sud parita). daje hodin jsou vyslny mezi
; 29. a 34. sekundou (4 + 2 bity), ve 35. sekund je vysln paritn bit pro
; hodiny. Mezi 36. a 41. sekundou je vysln den (4 + 2 bity), mezi
; 42. a 44. sekundou je vysln den v tdnu (3 bity, 0=nedle), mezi 45.
; a 49. sekundou je vysln msc a mezi 50. a 57. sekundou je vysln
; rok (4 + 4 bity, pouze 2 posledn slice bez stolet). V 58. sekund
; je vysln paritn bit pro datum. Zatek minuty se synchronizuje
; vyhodnocenm minutov znaky, kter je vytvoena chybjc sekundovou
; znakou v 59. sekund. Vysla DCF77 je v chodu nepetrit krom
; kadho druhho ter v msci mezi 5. a 9. hodinou (probh technick
; drba).
; -----------------------------------------------------------------------------
; Port COM: vstup DTR (pin 20) = +12V   (+ napjen DCF)
;           vstup RTS (pin  4) = -12V   (- napjen DCF)
;           vstup  CTS (pin  5) = impuls -12V -> +12V
;           zem    GND (pin  7) = 0V     (zem DCF)
; -----------------------------------------------------------------------------

bit0     EQU       1
bit1     EQU       2
bit2     EQU       4
bit3     EQU       8
bit4     EQU       10h
bit5     EQU       20h
bit6     EQU       40h
bit7     EQU       80h

HI       EQU       256

KORIG    EQU       5ch - 103h               ; korekce pro posun adres

KLICFN   EQU       2bh*HI + "?"             ; kl funkce a dotazu
KLIC1    EQU       'DC'                     ; identifikan kl 1 (BX)
KLIC2    EQU       'F7'                     ; identifikan kl 2 (CX)
KLIC3    EQU       '7'                      ; identifikan kl 3 (DH)
                                            ; DL=posledn slice poadovho
                                            ;    sla licennho sla
KLICOK   EQU       'OK'                     ; odpovdn kl (AX)


Code     SEGMENT
         ASSUME    cs:Code,ds:Code
         ORG       100h

Start:   jmp       Instal

RezBeg   label     byte                     ; zatek rezidentn sti

Ident    db        'F'                      ; identifikace v pamti
                                           ;* pouv se t 1.znak z lic.sla!
Licence  db        '7000013752'             ; licenn slo "XXXXX-XXXXX"
                                            ;   0: identifikace DCF77 = "7"
                                            ;   1 a 4: poadov slo 1 a 9999
                                            ;           (0=neinicializovno)
                                            ;   5: verze programu
                                            ;   6: rozlien "0"/"1" (=3)
                                            ;   7: poet zavdcch bit - 13 (=7)
                                            ;   8: korekce asu v 1/18 sek. (=5)
                                            ;   9: doplnk kontrolnho soutu
                                            ;      pedelch slic na 5 (MOD 10)
                                            ; - posledn slice poadovho sla
                                            ;  se pouv k identifikaci v pamti
                                            ;  (s vce sly me bt vce driver)
                                            ; - souet vech slic (=slo 5)
                                            ;   pedstavuje poet bit na msc

Old08    dd        342343242                ; uschovan adresa INT 08h
Old21    dd        453453443                ; uschovan adresa INT 21h
Old28    dd        45454                    ; pvodn adresa obsluhy INT 28h
Aktiv21  dd        53454343                 ; adresa pznaku aktivity DOS (-1=nen)
ErrDOS   dd        154353454                ; adresa pznaku obsluhy chyby DOS

Port     db        -1                       ; slo portu 0 a 3 (-1=vypnuto)
OutPort  dw        23423                    ; adresa vstupnho portu

Param    db        bit4                     ; parametry
                                            ;   bit 0: 1=je signl
                                            ;   bit 1: 1=bylo 1. naten asu
                                            ;   bit 2: 1=byla korekce asu
                                            ;   bit 3: 1=je impuls
                                            ;   bit 4: 1=ek se na min. znaku
                                            ;   bit 5: 1=poadavek nastaven DOS
                                            ;   bit 6: 1=ek se na START bit
                                            ;   bit 7: 1=ek se na paritn bit

MinutaL  db        0                        ; minuta posledn korekce asu
HodinaL  db        0                        ; hodina posledn korekce asu
CitSek   db        0                        ; ta ubhl sekundy 0 a 59

LoadBit  db        20                       ; ta startovacch bit
Ukaz     dw        offset Zprava+KORIG      ; ukazatel zprvy
UkazBit  db        7                        ; poet bit k naten

Parita   db        0                        ; stada parity

Korekce  dw        0                        ; ta korekce 55 ms

Setina   db        0                        ; setina sekundy
Sekunda  db        0                        ; sekunda

Zprava   label     byte                     ; zprva (data BCD/bit/min/max)
Minuta   db        80h,7+bit7,0,59          ; minuta (+ parita)
Hodina   db        80h,6+bit7,0,23          ; hodina (+ parita)
Den      db        80h,6,1,31               ; den
Tyden    db        80h,3,1,7                ; den v tdnu (1 a 7 = PO a NE)
Mesic    db        80h,4,1,12               ; msc (poet bit neplatn !)
;Mesic    db        80h,5,1,12               ; msc
Rok      db        80h,8+bit7,0,99          ; rok bez stolet (+ parita)

Zprava0  label     byte                     ; posledn poloka

Uschova  db        6*4 dup(2ah)             ; schova zprvy

CitacImp dw        0                        ; ta dlky impulsu
CitacMez dw        0                        ; ta dlky mezery

CitNext  dw        1                        ; ta do ptho ten (65543-2731)
                                            ; (1 hodina - pedbh 60+60+30 sekund)

MinNext  dw        62812                    ; interval pt aktualizace - 2731

; -----------------------------------------------------------------------------
;        obsluha INT 08h
; -----------------------------------------------------------------------------

Int08    PROC      FAR

; ------ tn korekce pro nastaven asu

         inc       word ptr cs:[Korekce+KORIG] ; tn korekce pi pjmu

; ------ tn ptho ten

         dec       word ptr cs:[CitNext+KORIG] ; tn doby do ptho ten
         jnz       Int080                   ; doby jet nen dosaeno
         inc       word ptr cs:[CitNext+KORIG] ; nvrat tae

; ------ test, zda je obsluha zapnuta

         cmp       byte ptr cs:[Port+KORIG],-1 ; je funkce vypnuta ?
         je        Int080                   ; funkce je vypnuta
         test      byte ptr cs:[Param+KORIG],bit5 ; poadavek DOS ?
         jz        Int081                   ; funkce nen vypnuta
Int080:  jmp       dword ptr cs:[Old08+KORIG] ; pvodn obsluha INT 08h

; ------ pvodn obsluha INT 08h

Int081:  pushf
         call      dword ptr cs:[Old08+KORIG] ; pvodn obsluha INT 08h

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      dx
         push      si
         push      di
         push      ds
         push      es

         push      cs
         pop       ds                       ; DS <- datov segment
         push      cs
         pop       es                       ; ES <- datov segment

; ------ vysln signlu na port

         mov       dx,ds:[OutPort+KORIG]    ; vstupn port
         mov       al,bit0+bit3
         out       dx,al                    ; nastaven signl

; ------ naten stavu portu

         inc       dx
         inc       dx                       ; vstupn port
         in        al,dx                    ; naten stavu portu
         test      al,bit4                  ; je impuls ?
         jz        Int082                   ; nen impuls

; ------ je impuls (pp. konec mezery)

         test      byte ptr ds:[Param+KORIG],bit3 ; je ji impuls ?
         jz        Int0812                  ; nebyl impuls
Int0810A:inc       word ptr ds:[CitacImp+KORIG] ; tn dlky impulsu
         cmp       word ptr ds:[CitacImp+KORIG],9 ; asi tak maximln impuls
         jb        Int0810
         dec       word ptr ds:[CitacImp+KORIG] ; omezen dlky impulsu
         and       byte ptr ds:[Param+KORIG],not bit0 ; pznak, e nen signl
Int0810: jmp       Int086

Int0812: or        byte ptr ds:[Param+KORIG],bit0 ; pznak, e je signl
         mov       ax,ds:[CitacMez+KORIG]   ; ta mezery
         cmp       ax,11                    ; minimln dlka mezery
         jb        Int0822A                 ; pli krtk mezera
         mov       word ptr ds:[CitacImp+KORIG],0 ; nulovn tae impulsu
         or        byte ptr ds:[Param+KORIG],bit3 ; pznak impulsu

; ------ pila minutov znaka

         cmp       ax,30                    ; asi tak minutov znaka
         jb        Int0810                  ; nen minutov znaka
         cmp       ax,39                    ; asi tak maximum
         ja        Int08121                 ; pli dlouh mezera - znovu
         and       byte ptr ds:[Param+KORIG],not bit4 ; konec ekn na znaku
         jmp       Int088             ; zahjen pjmu

Int08121:and       byte ptr ds:[Param+KORIG],not bit0 ; pznak, e nen signl
         jmp       Int0872                  ; mal mezera - chyba

; ------ je mezera (pp. konec impulsu)

Int082:  test      byte ptr ds:[Param+KORIG],bit3 ; je ji mezera ?
         jnz       Int0822                  ; nebyla mezera
Int0822A:inc       word ptr ds:[CitacMez+KORIG] ; tn dlky mezery
         cmp       word ptr ds:[CitacMez+KORIG],50 ; asi tak maximln mezera
         jb        Int0810
         dec       word ptr ds:[CitacMez+KORIG] ; omezen dlky mezery
         and       byte ptr ds:[Param+KORIG],not bit0 ; pznak, e nen signl
         jmp       short Int0810

Int0822: or        byte ptr ds:[Param+KORIG],bit0 ; pznak, e je signl
         mov       ax,ds:[CitacImp+KORIG]   ; ta impulsu
         or        ax,ax                    ; minimln dlka impulsu
         jz        Int0810A                 ; impuls pli krtk
         mov       word ptr ds:[CitacMez+KORIG],0 ; nulovn tae mezery
         and       byte ptr ds:[Param+KORIG],not bit3 ; pznak mezery

; ------ pli dlouh impuls je chyba

         cmp       ax,5                     ; asi tak maximum
         jae       Int08121                 ; pli dlouh impuls - chyba

; ------ rozlien logick hodnoty impulsu

         add       al,"0"
         cmp       al,ds:[Licence+KORIG+6]  ; (=3) je "1" ?
         mov       al,0
         jb        Int0823
         inc       ax
Int0823: inc       byte ptr ds:[CitSek+KORIG] ; ta ubhl sekundy

; ------ tn zavdcch bit

         cmp       byte ptr ds:[LoadBit+KORIG],0 ; jsou zavdc bity ?
         je        Int0824                  ; nejsou zavdc bity
         or        byte ptr ds:[Param+KORIG],bit6 ; ek se na START bit
         dec       byte ptr ds:[LoadBit+KORIG] ; tn zavdcch bit
         cmp       byte ptr ds:[LoadBit+KORIG],6 ; tolik bit se neporovnv
         jb        Int08232                 ; je ji mlo bit
         cmp       al,0                     ; je "0" ?
         jne       Int08250                 ; chyba
Int08232:jmp       Int086

; ------ START bit

Int0824: test      byte ptr ds:[Param+KORIG],bit6 ; ek se na START bit ?
         jz        Int0825                  ; neek se na START bit
         and       byte ptr ds:[Param+KORIG],not bit6 ; zruen pznaku
         cmp       al,1                     ; je START bit ?
         jne       Int08250                 ; chyba pjmu
         jmp       Int086                   ; je START bit OK

Int08244:jmp       Int08259                 ; neek se na paritn bit

; ------ naten paritnho bitu

Int0825: mov       bx,ds:[Ukaz+KORIG]

         xor       byte ptr ds:[Parita+KORIG],al ; tn bitu parity
         test      byte ptr ds:[Param+KORIG],bit7 ; ek se na paritn bit ?
         jz        Int08244                 ; neek se na paritn bit

         and       byte ptr ds:[Param+KORIG],not bit7 ; zruen pznaku
         cmp       byte ptr ds:[Parita+KORIG],0 ; je parita OK ?
         je        Int08251
Int08250:jmp       Int087                  ; chyba parity

; ------ test, zda je ji konec

Int08251:cmp       bx,offset Zprava0+KORIG  ; je ji konec ?
         jae       Int08252
         jmp       Int086                   ; nen jet konec

; ------ porovnn, je-li ovovac ten

Int08252:test      byte ptr ds:[Param+KORIG],bit1 ; je to prvn ten ?
         jz        Int08257                 ; je to prvn ten

         mov       si,offset Zprava+KORIG   ; naten zprva
         mov       di,offset Uschova+KORIG  ; buffer schovy
         mov       cx,offset(Zprava0-Zprava) ; dlka zprvy
         cld
         repe      cmpsb                    ; porovnn zprvy
         jne       Int08257                 ; porovnn nesouhlas - znovu uvit

; ------ je oven OK - nastaven asu

         mov       byte ptr ds:[Sekunda+KORIG],0
         mov       byte ptr ds:[Setina+KORIG],0

         mov       ah,0
         mov       al,ds:[Licence+8+KORIG]  ; dodaten korekce "5"
         add       ax,-36+3 - "5"           ; tolik impuls po zatek minuty
         add       ax,ds:[CitacImp+KORIG]   ; odeten uplynulho asu
         mov       word ptr ds:[Korekce+KORIG],ax ; doba do nastaven asu
         or        byte ptr ds:[Param+KORIG],bit5 ; poadavek nastaven DOS
         jmp       Int087                   ; pjem dal zprvy

; ------ pprava pro opakovn pjmu

Int08257:or        byte ptr ds:[Param+KORIG],bit1 ; bude ovovac ten
         inc       byte ptr ds:[Minuta+KORIG] ; pednastaven minuty + 1
         cmp       byte ptr ds:[Minuta+KORIG],60
         jb        Int08258
         mov       byte ptr ds:[Minuta+KORIG],0
         inc       byte ptr ds:[Hodina+KORIG]
Int08258:mov       si,offset Zprava+KORIG   ; naten zprva
         mov       di,offset Uschova+KORIG  ; buffer schovy
         mov       cx,offset(Zprava0-Zprava) ; dlka zprvy
         cld
         rep       movsb                    ; schova zprvy
         jmp       Int0872                  ; pjem dal zprvy

; ------ naten bitu do sla

Int08259:shr       al,1                     ; bit do CF
         rcr       byte ptr ds:[bx],1       ; rotace do sla
         dec       byte ptr ds:[UkazBit+KORIG] ; ta bit
         jnz       Int086                   ; bude dal bit

; ------ rotace sla na pozici

         mov       al,ds:[bx+1]             ; poadovan poet bit
         and       al,0fh                   ; poadovan poet bit
         cmp       al,7                     ; je velk poet bit (=rok) ?
         ja        Int08262                 ; je velk poet bit (=rok)
Int0826: shr       byte ptr ds:[bx],1
         jnc       Int0826

; ------ konverze sla na binrn tvar

Int08262:mov       al,ds:[bx]               ; naten hodnota
         mov       ah,al
         mov       cl,4
         shr       ah,cl
         and       ax,0f0fh
         aad
         mov       ds:[bx],al

; ------ kontrola peteen sla

         cmp       al,ds:[bx+2]             ; minimln hodnota
         jb        Int087                   ; podteen
         cmp       al,ds:[bx+3]             ; maximln hodnota
         ja        Int087                   ; peteen

; ------ test, zda bude paritn bit

         test      byte ptr ds:[bx+1],bit7  ; bude paritn bit ?
         jz        Int0827                  ; nebude paritn bit
         or        byte ptr ds:[Param+KORIG],bit7 ; bude paritn bit

; ------ zven ukazatele dat

Int0827: add       bx,4
         mov       ds:[Ukaz+KORIG],bx       ; nov ukazatel dat

; ------ test, zda je ji konec

         cmp       bx,offset Zprava0+KORIG  ; je ji konec ?
         jae       Int086                   ; je ji konec
         mov       byte ptr ds:[bx],80h     ; pprava stadae dat
         mov       al,ds:[bx+1]             ; poet bit
         and       al,not bit7              ; nulovn pznaku parity
         mov       ds:[UkazBit+KORIG],al    ; ukazatel bit

; ------ nulovn pi ekn na minutovou znaku

Int086:  test      byte ptr ds:[Param+KORIG],bit4 ; ek se na znaku ?
         jz        Int089                   ; neek se na znaku
         jmp       short Int088             ; ek se

; ------ CHYBA - inicializace natn dat na zatek

Int087:  and       byte ptr ds:[Param+KORIG],not bit1 ; bude 1. ten
Int0872: or        byte ptr ds:[Param+KORIG],bit4 ; ek se na minutovou znaku
Int088:  mov       word ptr ds:[Ukaz+KORIG],offset Zprava+KORIG ; inicializace ukazatele
         mov       byte ptr ds:[UkazBit+KORIG],7 ; ta bit k naten - minuta
         mov       byte ptr ds:[CitSek+KORIG],0 ; ta ubhl sekundy
         mov       al,ds:[Licence+7+KORIG]  ; poet zavdcch bit - 13 ("7")
         add       al,20-"7"
         mov       ds:[LoadBit+KORIG],al    ; ta zavdcch bit
         mov       byte ptr ds:[Parita+KORIG],0  ; stada parity
         test      byte ptr ds:[Param+KORIG],bit5 ; je nastaven DOS ?
         jnz       Int089                   ; je nastaven DOS
         mov       byte ptr ds:[Minuta+KORIG],80h ; minuta neplatn

; ------ nvrat registr

Int089:  pop       es
         pop       ds
         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         iret

Int08    ENDP

; -----------------------------------------------------------------------------
;        obsluha INT 21h
; -----------------------------------------------------------------------------

Int21    PROC      FAR

; ------ test instalace

         pushf
         cmp       ax,KLICFN                ; funkn kl
         jne       Int212
         cmp       bx,KLIC1                 ; identifikan kl 1
         jne       Int212
         cmp       cx,KLIC2                 ; identifikan kl 2
         jne       Int212
         cmp       dh,KLIC3                 ; identifikan kl 3
         jne       Int212
         cmp       dl,cs:[Licence+KORIG+4]  ; posledn slice licence
         jne       Int212
         mov       ax,KLICOK                ; odpovdn kl
         push      cs
         pop       es                       ; ES <- segment programu
         popf
         iret

Int212:  popf

; ------ obsluha INT 21h

         call      IntDOS                   ; obsluha pstupu k DOS
         jmp       dword ptr cs:[Old21+KORIG] ; pokraovn pvodn obsluhou

Int21    ENDP

; -----------------------------------------------------------------------------
;        obsluha INT 28h
; -----------------------------------------------------------------------------

Int28    PROC      FAR

         call      IntDOS                   ; obsluha pstupu k DOS
         jmp       dword ptr cs:[Old28+KORIG] ; pokraovn pvodn obsluhou

Int28    ENDP

; -----------------------------------------------------------------------------
;        obsluha pstupu k DOS
; -----------------------------------------------------------------------------

IntDOS   PROC      NEAR

; ------ test, zda m bt obsluha asu DOS

         pushf
         cmp       word ptr cs:[Korekce+KORIG],8000h
         jae       IntDOS0                  ; nen jet dosaeno asu
         test      byte ptr cs:[Param+KORIG],bit5 ; poadavek obsluhy DOS ?
         jnz       IntDOS1                  ; je poadavek obsluhy DOS
IntDOS0: jmp       IntDOS9                  ; nen poadovna obsluha DOS

; ------ test pznaku aktivity DOS

IntDOS1: push      ds
         push      bx
         lds       bx,cs:[Aktiv21+KORIG]    ; adresa pznaku aktivity DOS
         cmp       bx,-1                    ; je adresa definovna ?
         je        IntDOS2                  ; nen definovna
         cmp       byte ptr ds:[bx],0       ; je DOS aktivn ?
IntDOS2: pop       bx
         pop       ds
         jne       IntDOS0                  ; DOS je aktivn

; ------ test pznaku obsluhy chyby DOS

         push      ds
         push      bx
         lds       bx,cs:[ErrDOS+KORIG]     ; adresa pznaku obsluhy chyby DOS
         cmp       bx,-1                    ; je adresa definovna ?
         je        IntDOS3                  ; nen definovna
         cmp       byte ptr ds:[bx],0       ; je chyba DOS aktivn ?
IntDOS3: pop       bx
         pop       ds
         jne       IntDOS0                  ; obsluha chyby DOS je aktivn

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      dx
         push      ds

         push      cs
         pop       ds                       ; DS <- CS

; ------ korekce asu

         mov       ax,ds:[Korekce+KORIG]    ; korekce asu
         cmp       ax,30*18                 ; maximln prodleva 30 sekund
         jbe       IntDOS4                  ; je to OK
         jmp       IntDOS8                  ; to je ji pli dlouho

IntDOS4: mov       cx,100
         mul       cx
         mov       cl,18
         div       cx                       ; pepoet na 1/100 sekund
                                          ;* zde je AX maximln 3000
         add       al,ds:[Setina+KORIG]     ; piten 1/100 sekund
         adc       ah,0
         mov       cl,100
         div       cl                       ; pepoet na sekundy a setiny
         mov       ds:[Setina+KORIG],ah     ; setina sekundy
         add       ds:[Sekunda+KORIG],al    ; korekce sekund
         cmp       byte ptr ds:[Sekunda+KORIG],60
         jb        IntDOS5
         sub       byte ptr ds:[Sekunda+KORIG],60
         inc       byte ptr ds:[Minuta+KORIG] ; korekce minut (peteen ignoruje)

; ------ nastaven asu DOS

IntDOS5: mov       ch,ds:[Hodina+KORIG]     ; hodina
         mov       cl,ds:[Minuta+KORIG]     ; minuta
         mov       dh,ds:[Sekunda+KORIG]    ; sekunda
         mov       dl,ds:[Setina+KORIG]     ; setina sekundy
         mov       ah,2dh
         call      Int21P                   ; nastaven systmovho asu
         cmp       al,0                     ; byl as OK ?
         jne       IntDOS8                  ; nebyl sprvn as

; ------ nastaven data DOS

IntDOS6: mov       cl,ds:[Rok+KORIG]        ; rok bez stolet
         mov       ch,0

         add       cx,1900
         cmp       cx,1980
         jae       IntDOS7
         add       cx,100

IntDOS7: mov       dh,ds:[Mesic+KORIG]      ; msc
         mov       dl,ds:[Den+KORIG]        ; den
         mov       ah,2bh
         call      Int21P                   ; nastaven systmovho data
         cmp       al,0                     ; bylo datum OK ?
         jne       IntDOS8                  ; nebylo sprvn datum

         mov       ah,ds:[Hodina+KORIG]     ; hodina
         mov       al,ds:[Minuta+KORIG]     ; minuta
         mov       ds:[HodinaL+KORIG],ah    ; naposledy proveden korekce
         mov       ds:[MinutaL+KORIG],al    ; naposledy proveden korekce
         or        byte ptr ds:[Param+KORIG],bit2 ; pznak proveden korekce
         mov       ax,ds:[MinNext+KORIG]    ; interval (62812)
         mov       word ptr ds:[CitNext+KORIG],ax ; ta do pt korekce

IntDOS8: and       byte ptr ds:[Param+KORIG],not bit5 ; zruen poadavku
         mov       byte ptr ds:[Minuta+KORIG],80h ; minuta neplatn

; ------ nvrat registr

         pop       ds
         pop       dx
         pop       cx
         pop       bx
         pop       ax
IntDOS9: popf
         ret

IntDOS   ENDP

; -----------------------------------------------------------------------------
;        voln funkce DOS (DS=CS !)
; -----------------------------------------------------------------------------

Int21P   PROC      NEAR

         pushf
         call      dword ptr ds:[Old21+KORIG]
         ret

Int21P   ENDP

RezEnd   label     byte                     ; konec rezidentnho modulu

; *****************************************************************************
;
;                          Start a instalace programu
;
; *****************************************************************************
;
; ------ naten adres obsluh peruen

Instal:  call      GetInt                   ; naten adres peruen

; ------ schova pkazovho dku do bufferu

         push      ds
         pop       es                       ; ES <- DS
         mov       si,81h                   ; pkazov dek
         mov       cl,ds:[si-1]             ; dlka pkazovho dku
         mov       ch,0
         and       cl,7fh                   ; pojistka proti peteen
         mov       di,offset ComLine        ; buffer pkazovho dku
         cld
         rep       movsb                    ; schova pkazovho dku
         mov       al,0                     ; koncov nula
         stosb                              ; oznaen konce pkazovho dku

; ------ posun programu ne (ES=DS, CLD !)

         mov       si,offset RezBeg         ; zatek rezidentnho modulu
         mov       di,offset RezBeg + KORIG ; nov zatek rezidentnho modulu
         mov       cx,offset(RezEnd-RezBeg) ; dlka rezidentnho modulu
         rep       movsb                    ; pesun programu ne

; ------ kontroln souet licennho sla -> poet bit na msc

         mov       si,offset Licence+KORIG
         mov       cl,10
         push      cx
         mov       ah,0
Instal02:add       al,ds:[si]
         inc       si
         adc       ah,0
         loop      Instal02                 ; k soutu je piteno 480 (=10*"0")
         pop       cx
         div       cl
         mov       ds:[Mesic+KORIG+1],ah    ; poadovan poet bit = 5

; ------ test, je-li program rezidentn (DS=ES !)

         mov       ax,KLICFN                ; kl funkce a dotazu
         mov       bx,KLIC1                 ; identifikan kl 1
         mov       cx,KLIC2                 ; identifikan kl 2
         mov       dh,KLIC3                 ; identifikan kl 3
         mov       dl,ds:[Licence+KORIG+4]  ; posledn slice licence
         int       21h                      ; test instalace
         cmp       ax,KLICOK                ; odpovdn kl
         jne       Instal1                  ; program nen rezidentn
         cmp       word ptr es:[Ident+KORIG],"7F" ; souhlas identifikace ?
         je        Instal2                  ; program je rezidentn OK

Instal1: push      cs
         pop       es                       ; ES <- segment tohoto programu
         and       byte ptr ds:[InstPar],not bit0 ; nen rezidentn

; ------ naten znaku z pkazovho dku (ES=rezidentn segment)

Instal2: mov       si,offset ComLine        ; buffer pkazovho dku
Instal22:call      RozbChr                  ; naten znaku
         jc        Instal5                  ; nen dal znak

; ------ odinstalovn programu z pamti

         cmp       al,"!"                   ; odinstalovn ?
         jne       Instal3                  ; nen odinstalovn
         jmp       OdInst                   ; odinstalovn programu

; ------ okamit aktualizace asu

Instal3: cmp       al,"A"
         jne       Instal32                 ; nen aktualizace
         mov       word ptr es:[CitNext+KORIG],1 ; zruen ekn
;         or        byte ptr ds:[InstPar],bit3 ; okamit aktualizace
         jmp       short Instal22

; ------ opakovan zobrazovn

Instal32:cmp       al,"D"
         jne       Instal33
         or        byte ptr ds:[InstPar],bit2 ; opakovan zobrazovn
         jmp       short Instal22

; ------ interval pro opakovn

Instal33:cmp       al,"I"
         jne       Instal36
         call      RozbNum

         mov       dx,1092
         mul       dx                       ; pepoet na impulsy
         sub       ax,2731                  ; bez 150 sekund
         ja        Instal34
         mov       ax,1
Instal34:mov       es:[MinNext+KORIG],ax    ; pt aktualizace
         jmp       short Instal22

; ------ vypnut funkce

Instal36:cmp       al,"0"
         jne       Instal4
         or        byte ptr ds:[InstPar],bit1 ; zadno slo portu
         mov       byte ptr es:[Port+KORIG],-1 ; vypnut funkce
         jmp       short Instal22

; ------ zadn sla portu

Instal4: sub       al,"1"
         jb        Chyba00
         cmp       al,3
         ja        Chyba00
         or        byte ptr ds:[InstPar],bit1 ; zadno slo portu
         call      InstPort                 ; instalace portu AL
         jc        ChybaX                   ; chyba - port neexistuje
         jmp       short Instal22

Chyba00: jmp       Chyba0

ChybaX:  jmp       Chyba

; ------ nainstalovn programu

Instal5: test      byte ptr ds:[InstPar],bit0 ; je ji nainstalovn ?
         jnz       Instal6                  ; je ji nainstalovn
         test      byte ptr ds:[InstPar],bit1 ; m bt instalace ?
         jz        Chyba0                   ; nezadna instalace - chyba
         jmp       Inst                     ; instalace programu

; ------ pouze zobrazen stavu

Instal6: cmp       byte ptr es:[Port+KORIG],-1 ; funkce vypnuta ?
         je        Instal62                 ; funkce vypnuta

         test      byte ptr ds:[InstPar],bit2 ; opakovan zobrazovn ?
         jnz       Instal7                  ; je opakovan zobrazovn
Instal62:call      DispUv                   ; zobrazen vodnho textu
         call      DispStav                 ; zobrazen stavu
         int       20h

; ------ opakovan zobrazovn stavu

Instal7: push      ds
         push      es

         mov       ah,0fh
         int       10h
         cmp       al,7
         je        Instal72
         mov       al,3
Instal72:mov       ah,0
         int       10h                      ; vymazn obrazovky

         pop       es
         pop       ds

Instal74:
;test      byte ptr ds:[InstPar],bit3 ; okamzita aktualizace ?
;         jz        Instal75                 ; neni
;         mov       word ptr es:[CitNext+KORIG],1 ; zruen ekn

Instal75:mov       ah,2ch
         int       21h                      ; poskytnut systmovho asu -> DX

         push      dx                       ; schova sekund + setin

         push      ds
         push      es

         xor       dx,dx
         mov       ah,2
         mov       bh,0
         int       10h                      ; kurzor na potek obrazovky

         pop       es
         pop       ds

         call      DispStav

         pop       si                       ; SI <- uschovan sekundy + setiny

Instal76:mov       ah,2ch
         int       21h
         cmp       dx,si
         jne       Instal78
         mov       ah,1
         int       16h
         jz        Instal76

Instal78:mov       ah,1
         int       16h
         jz        Instal74                 ; ekn na stisk klvesy

         mov       ah,0
         int       16h
         int       20h

; ------ hlen chyby

Chyba0:  call      DispUv                   ; zobrazen vodnho textu
         mov       dx,offset HelpTxt        ; chybov hlen
Chyba:   call      DispTxt                  ; zobrazen chyby
         int       20h

; -----------------------------------------------------------------------------
;        zobrazen vodnho texty (mus uchovat ES)
; -----------------------------------------------------------------------------

DispUv   PROC      NEAR

         push      es
         push      ds
         pop       es
         mov       si,offset Licence+KORIG  ; licenn slo
         mov       di,offset UvTxt1
         cld
         mov       cx,5
         rep       movsb                    ; penos sla - 1. st
         inc       di
         mov       cl,5
         rep       movsb                    ; penos sla - 2. st

         mov       dx,offset UvTxt
         call      DispTxt                  ; zobrazen vodnho textu
         pop       es
         ret

DispUv   ENDP

; -----------------------------------------------------------------------------
;                            instalace programu
; -----------------------------------------------------------------------------

; ------ hlen o nainstalovn

Inst:    call      DispUv                   ; zobrazen vodnho textu
         mov       dx,offset InstTxt
         call      DispTxt                  ; hlen o nainstalovn

; ------ instalace obsluh INT 08h, INT 21h a INT 28h

         mov       ax,2508h
         mov       dx,offset INT08+KORIG
         int       21h                      ; instalace INT 08h

         mov       ax,2521h
         mov       dx,offset INT21+KORIG
         int       21h                      ; instalace INT 21h

         mov       ax,2528h
         mov       dx,offset INT28+KORIG
         int       21h                      ; instalace INT 28h

; ------ uvolnn segmentu prosted

         mov       es,ds:[2ch]              ; segment prosted
         mov       ah,49h
         int       21h                      ; uvolnn segmentu prosted

; ------ instalace programu

         mov       dx,offset RezEnd+KORIG   ; konec rezidentnho modulu
         int       27h                      ; instalace do pamti

; -----------------------------------------------------------------------------
;        naten adres peruen
; -----------------------------------------------------------------------------

GetInt   PROC      NEAR

; ------ schova adresy INT 08h

         mov       ax,3508h
         int       21h                      ; poskytnut adresy INT 08h
         mov       word ptr ds:[Old08],bx   ; schova INT 08h
         mov       word ptr ds:[Old08+2],es

; ------ schova adresy INT 21h

         mov       ax,3521h
         int       21h                      ; poskytnut adresy INT 21h
         mov       word ptr ds:[Old21],bx   ; schova INT 21h
         mov       word ptr ds:[Old21+2],es

; ------ schova adresy INT 28h

         mov       ax,3528h
         int       21h                      ; poskytnut adresy INT 28h
         mov       word ptr ds:[Old28],bx
         mov       word ptr ds:[Old28+2],es

; ------ instalace pznaku aktivity DOS

         mov       bx,-1                    ; BX <- 0ffffh nepovolen hodnota
         mov       es,bx                    ; ES <- 0ffffh nepovolen hodnota
         mov       ah,34h
         int       21h                      ; poskytnut pznaku aktivity DOS
         mov       ax,es
         inc       ax                       ; m ES povolenou hodnotu ?
         jnz       GetInt2                  ; ES je definovno OK
         mov       bx,es                    ; ES i BX maj hodnotu 0ffffh
GetInt2: mov       word ptr ds:[Aktiv21],bx ; adresa pznaku aktivity DOS
         mov       word ptr ds:[Aktiv21+2],es ; segment pznaku aktivity DOS

; ------ instalace pznaku obsluhy chyby DOS

         push      ds
         mov       si,-1                    ; SI <- 0ffffh nepovolen hodnota
         mov       ds,si                    ; DS <- 0ffffh nepovolen hodnota
         mov       ax,5d06h
         int       21h                      ; poskytnut pznaku chyby DOS
         jnc       GetInt4                  ; operace OK
         mov       si,-1                    ; adresa je neplatn
GetInt4: mov       ax,ds                    ; segment adresy
         inc       ax                       ; m DS povolenou hodnotu ?
         jnz       GetInt6                  ; DS je definovno OK
         mov       si,ds                    ; DS i SI maj hodnotu 0ffffh
GetInt6: dec       ax                       ; nvrat DS
         pop       ds
         mov       word ptr ds:[ErrDOS],si  ; adresa pznaku aktivity DOS
         mov       word ptr ds:[ErrDOS+2],ax ; segment pznaku aktivity DOS
         ret

GetInt   ENDP

; -----------------------------------------------------------------------------
;        zobrazen stavu programu (ES=rezidentn segment)
; -----------------------------------------------------------------------------

DispStav PROC      NEAR

; ------ program je neaktivn

         cmp       byte ptr es:[Port+KORIG],-1 ; funkce vypnuta ?
         jne       DispStv0
         mov       dx,offset NeAktTxt       ; program neaktivn
         call      DispTxt
         ret

; ------ pprava sla portu

DispStv0:mov       al,es:[Port+KORIG]       ; slo portu
         add       al,"1"
         mov       byte ptr ds:[LastTxt1],al ; slo portu

; ------ stav signlu

         mov       si,offset LastTx28       ; je ekn
         cmp       word ptr es:[CitNext+KORIG],1 ; probh natn ?
         ja        DispStv1                 ; neprobh natn
         mov       si,offset LastTx24       ; je pjem
         test      byte ptr es:[Param+KORIG],bit0 ; je signl ?
         jnz       DispStv1                 ; je signl OK
         mov       si,offset LastTx26       ; nen pjem
DispStv1:mov       di,offset LastTxt2
         push      es
         push      ds
         pop       es                       ; ES <- DS
         cld
         movsw
         movsw
         movsw
         movsw
         pop       es

         mov       byte ptr ds:[LastTx22]," " ; jen impuls
         mov       dx,es:[OutPort+KORIG]    ; vstupn port
         inc       dx
         inc       dx                       ; vstupn port
         in        al,dx                    ; naten stavu portu
         test      al,bit4                  ; je impuls ?
         jz        DispStv2                 ; nen impuls
         mov       byte ptr ds:[LastTx22],"*" ; pznak signlu

; ------ zobrazen dku s slem portu COM

DispStv2:mov       dx,offset PrijCOM
         call      DispTxt                  ; zobrazen textu

; ------ rozlien natn/oven

         mov       si,offset LastTx54       ; text "naten"
         test      byte ptr es:[Param+KORIG],bit1 ; je to oven ?
         jz        DispSt22                 ; je to prvn natn
         mov       si,offset LastTx52       ; text "oven"

DispSt22:mov       di,offset LastTxt5+4     ; text "naten"
         mov       cx,7                     ; dlka textu
         push      es
         push      ds
         pop       es
         cld
         rep       movsb                    ; penos textu
         pop       es

; ------ procento natn

         mov       al,es:[CitSek+KORIG]
         cmp       al,59
         jbe       DispStv3
         mov       al,59
DispStv3:mov       ah,100
         mul       ah
         mov       cl,60
         div       cl
         mov       di,offset LastTxt5
         call      DispStvB                 ; dekdovn procent

; ------ aktuln ukazatele

         mov       si,offset Hodina+KORIG
         mov       di,offset LastTxt4

         push      word ptr es:[si]
         mov       al,es:[si]               ; hodina
         call      DispStvH                 ; korekce
         mov       es:[si],al               ; oprava
         call      DispStvA                 ; dekdovn hodiny
         pop       word ptr es:[si-4]

         mov       si,offset Minuta+KORIG
         call      DispStvA                 ; dekdovn minuty
         inc       di

         mov       si,offset Mesic+KORIG
         call      DispStvA                 ; dekdovn msce
         mov       si,offset Den+KORIG
         call      DispStvA                 ; dekdovn dne

         inc       di
         inc       di                       ; zatek roku ve stolet
         push      si
         call      DispStvA                 ; dekdovn roku ve stolet
         pop       si

         mov       word ptr ds:[di-5],"--"  ; rok nen naten

         cmp       si,es:[Ukaz+KORIG]       ; je ji rok naten ?
         jae       DispStv4                 ; rok jet nen naten

         mov       word ptr ds:[di-5],"91"  ; bude stolet 19xx
         cmp       byte ptr ds:[di-3],"8"   ; je rok 8x a vce ?
         jae       DispStv4                 ; je to stolet 19xx
         mov       word ptr ds:[di-5],"02"  ; jinak je to stolet 2000

; ------ test, zda se nastavuje as

DispStv4:mov       dx,offset LastTx72
         test      byte ptr es:[Param+KORIG],bit5 ; je nastavovn asu ?
         jnz       DispStv5                 ; je nastavovn asu

; ------ test, zda probh natn

         mov       dx,offset LastTxt3       ; text - stav natn
         cmp       word ptr es:[CitNext+KORIG],1 ; probh natn ?
         jbe       DispStv5                 ; probh natn OK

; ------ zobrazen pt aktualizace asu

         mov       ax,es:[CitNext+KORIG]    ; ta do aktualizace asu
         xor       dx,dx                    ; DX <- 0
         mov       cx,18                    ; asi tak poet impuls na sekundu
         div       cx                       ; vpoet potu zbvajcch sekund
         add       ax,150+15                ; oprava
;
         push      ax                       ; schova potu sekund
         mov       ah,2ch
         int       21h                      ; poskytnut systmovho asu
         pop       ax
         add       al,dh                    ; piten sekund
         adc       ah,0
         mov       bl,60                    ; poet sekund na minutu
         div       bl                       ; pepoet na sekundy a minuty
         add       al,cl                    ; piten minut
         mov       ah,0
         div       bl                       ; pepoet na hodiny a minuty
         add       al,ch                    ; piten hodiny
         cmp       al,23                    ; je peteen ?
         jbe       DispSt42                 ; nen peteen
         sub       al,24                    ; oprava hodiny

DispSt42:mov       di,offset LastTxt7
         push      ax
         call      DispStvH                 ; korekce
         call      DispStvB                 ; dekdovn hodiny
         pop       ax
         mov       al,ah                    ; minuta
         call      DispStvB

         mov       dx,offset LastTxt6       ; text - pt aktualizace
DispStv5:call      DispTxt                  ; zobrazen stavu natn

; ------ as poslednho pjmu

         test      byte ptr es:[Param+KORIG],bit2 ; byla korekce ?
         jz        DispStv6                 ; nebyla korekce

         mov       al,es:[HodinaL+KORIG]    ; hodina pjmu
         mov       di,offset LastTxt9
         call      DispStvH                 ; korekce
         call      DispStvB
         mov       al,es:[MinutaL+KORIG]    ; minuta pjmu
         call      DispStvB

; ------ aktuln as a datum

DispStv6:mov       ah,2ch
         int       21h                      ; poskytnut systmovho asu
         mov       di,offset LastTxt0+6
         mov       al,ch                    ; hodina
         call      DispStvH                 ; korekce
         mov       di,offset LastTxt0
         call      DispStvB
         mov       al,cl                    ; minuta
         call      DispStvB
         mov       al,dh                    ; sekunda
         call      DispStvB
         mov       al,dl                    ; setina
         call      DispStvB

         mov       ah,2ah
         int       21h

         inc       di

         push      ax

         mov       al,dh                    ; msc
         call      DispStvB
         mov       al,dl                    ; den
         call      DispStvB
         mov       al,100
         xchg      ax,cx
         div       cl

         push      ax
         call      DispStvB                 ; stolet
         pop       ax

         dec       di
         mov       al,ah
         call      DispStvB                 ; rok

         mov       dx,offset LastTxt8
         call      DispTxt                  ; zobrazen aktulnho asu a data

         pop       ax

         mov       ah,12
         mul       ah
         add       ax,offset LastTxtD
         xchg      ax,dx
         call      DispTxt                  ; zobrazen dne v tdnu
         ret

DispStav ENDP

; ------ dekdovn sla es:[si] (resp. AL) do ds:[di]

DispStvA:cld
         mov       word ptr ds:[di],"--"
         cmp       si,es:[Ukaz+KORIG]       ; je to ji naten daj ?
         jae       DispStvC                 ; nen to jet naten daj
         mov       al,es:[si]               ; poadovan bajt

DispStvB:aam                                ; korekce na 2 slice
         or        ax,"00"                  ; korekce na ASCII
         xchg      al,ah                    ; oprava poad bajt
         mov       ds:[di],ax               ; uloen sla

DispStvC:add       di,3                     ; zven ukldac adresy
         add       si,4                     ; zven tec adresy
         ret

; ------ rozlien dopoledne/odpoledne

DispStvH:mov       byte ptr ds:[di+5],"a"   ; dopoledne
         cmp       al,12
         jb        DispStH2
         mov       byte ptr ds:[di+5],"p"   ; odpoledne
         sub       al,12
DispStH2:cmp       al,0
         jne       DispStH4
         mov       al,12
DispStH4:ret

; -----------------------------------------------------------------------------
;        odinstalovn programu (ES=rezidentn segment)
; -----------------------------------------------------------------------------

; ------ test, zda je program rezidentn

OdInst:  mov       dx,offset NeniTxt        ; nen nainstalovn
         test      byte ptr ds:[InstPar],bit0 ; je program rezidentn ?
         jz        OdInst6                  ; program nen rezidentn

; ------ test segment INT 08h, INT 21h a INT 28h

         mov       dx,offset NelzeTxt       ; hlen - nelze odinstalovat
         mov       ax,es                    ; AX <- rezidentn segment
         cmp       ax,word ptr ds:[Old08+KORIG+2] ; souhlas INT 08h ?
         jne       OdInst6                  ; nesouhlas
         cmp       ax,word ptr ds:[Old21+KORIG+2] ; souhlas INT 21h ?
         jne       OdInst6                  ; nesouhlas
         cmp       ax,word ptr ds:[Old28+KORIG+2] ; souhlas INT 28h ?
         jne       OdInst6                  ; nesouhlas

; ------ nvrat adresy INT 08h, INT 21h a INT 28h

         push      ds
         mov       ax,2508h
         lds       dx,es:[Old08+KORIG]      ; pvodn adresa INT 08h
         int       21h                      ; nvrat adresy INT 08h
         mov       ax,2521h
         lds       dx,es:[Old21+KORIG]      ; pvodn adresa INT 21h
         int       21h                      ; nvrat adresy INT 21h
         mov       ax,2528h
         lds       dx,es:[Old28+KORIG]      ; pvodn adresa INT 28h
         int       21h                      ; nvrat adresy INT 28h
         pop       ds

; ------ zruen segmentu programu

         mov       ah,49h
         int       21h                      ; uvolnn segmentu programu
         mov       dx,offset DInsTxt        ; hlen o odinstalovn
OdInst6: jmp       Chyba

; -----------------------------------------------------------------------------
;        instalace portu AL (ES=rezidentn segment)
; -----------------------------------------------------------------------------

InstPort PROC      NEAR

; ------ pprava textu pro hlen

         add       ds:[NeniCOM1],al         ; pprava textu pro hlen pro COM

; ------ adresa portu -> BX

         push      ds
         mov       bx,40h
         mov       ds,bx                    ; ES <- 40h
         mov       bl,al                    ; BX <- slo portu COM/LPT
         shl       bx,1
         mov       bx,ds:[bx]               ; adresa portu COM
         pop       ds

; ------ test, zda je port platn

         or        bx,bx                    ; je port platn ?
         jnz       InstPrt2                 ; port je platn OK
         mov       dx,offset NeniCOM        ; text pro COM
         stc                                ; pznak chyby
         ret

; ------ instalace portu COM

InstPrt2:mov       es:[Port+KORIG],al       ; slo portu COM
         add       bx,4                     ; dic registr modemu
         mov       es:[OutPort+KORIG],bx    ; vstupn port
         clc                                ; pznak operace OK
         ret

InstPort ENDP

; -----------------------------------------------------------------------------
;        naten sla z pkazovho dku -> AX
; -----------------------------------------------------------------------------

RozbNum  PROC      NEAR

         push      bx
         push      dx

         xor       bx,bx
RozbNum1:call      RozbChr                  ; naten dalho znaku
         jc        RozbNum9                 ; nen dal znak
         sub       al,"0"
         jb        RozbNum8
         cmp       al,9
         ja        RozbNum8

         push      ax
         mov       ax,10
         mul       bx
         pop       bx
         mov       bh,0
         add       bx,ax

         cmp       byte ptr ds:[si],"0"
         jb        RozbNum9
         jmp       short RozbNum1

RozbNum8:dec       si

RozbNum9:xchg      ax,bx
         pop       dx
         pop       bx
         ret

RozbNum  ENDP

; -----------------------------------------------------------------------------
;        naten znaku z pkazovho dku
; -----------------------------------------------------------------------------

RozbChr  PROC      NEAR

RozbChr1:cmp       byte ptr ds:[si],0       ; konec textu ?
         stc                                ; pznak, e nen dal znak
         je        RozbChr3                 ; konec textu
         cld
         lodsb                              ; naten znaku
         cmp       al," "                   ; je mezera nebo tabultor ?
         jbe       RozbChr1                 ; mezera nebo tabultor se ignoruje
         cmp       al,"/"                   ; oddlova parametr ?
         je        RozbChr1                 ; oddlova parametr se ignoruje
         cmp       al,"-"                   ; oddlova parametr ?
         je        RozbChr1                 ; oddlova parametr se ignoruje

         cmp       al,"a"
         jb        RozbChr2
         cmp       al,"z"
         ja        RozbChr2
         sub       al,32
RozbChr2:clc                                ; pznak operace OK

RozbChr3:ret

RozbChr  ENDP

; -----------------------------------------------------------------------------
;        zobrazen textu DS:DX
; -----------------------------------------------------------------------------

DispTxt  PROC      NEAR

         push      ax
         mov       ah,9
         int       21h                      ; zobrazen textu DS:DX
         pop       ax
         ret

DispTxt  ENDP

; *****************************************************************************
;
;                                   data
;
; *****************************************************************************
;
InstPar  db        bit0                     ; parametry
                                            ;   bit 0: 1=je rezident
                                            ;   bit 1: 1=zadno slo portu
                                            ;            nebo vypnut funkce
                                            ;   bit 2: 1=opakovan zobrazen
                                            ;    (bit 3: 1=okamzita aktualizace)

UvTxt    db        13,10
         db        '                     ',13,10
         db        '                      *                               * ۰',13,10
         db        '                          (c)  P H O B O S   s.r.o.     ۰',13,10
         db        '                         ͻ ͻ ͻ    ͻ ͻ    ۰',13,10
         db        '                                               ۰',13,10
         db        '                         ͼ ͼ                   ۰',13,10
         db        '                                 version 1.0            ۰',13,10
         db        '                                                        ۰',13,10
         db        '                      *     (c)  Miroslav Nemecek     * ۰',13,10
         db        '                     ۰',13,10
         db        '                       ',13,10
         db        '                              licence: '
UvTxt1   db        '00000-00000',13,10
         db        '$'

HelpTxt  db  13,10,'Switches: /0 ........... program turned off',13,10
         db        '          /1 az /4 ..... COM number with receiver DCF 77',13,10
         db        '          /A ........... immediate time loading',13,10
         db        '          /I minutes ... interval for next time actualisation',13,10
         db        '                         (in minutes, default=60)',13,10
         db        '          /D ........... display actual state (repeated)',13,10
         db        '          /! ........... remove program from memory',13,10
         db        'Without any parameter will be shown the actual state.',13,10
         db        '$'

NeAktTxt db        13,10,'Program in now NOT ACTIVE.',13,10,'$'

; ------ texty pro zobrazen stavu - dky mus zachovvat dlku, aby
;        pi opakovanm vpisu nezstvala star informace !

LastTx24 db        '(SIGNAL)'
LastTx26 db        '(------)'
LastTx28 db        '        '

PrijCOM  db        13,10,'Used port is COM'
LastTxt1 db        '1: '
LastTxt2 db        '(SIGNAL) '
LastTx22 db        ' ',13,10,'$'

LastTx52 db        ' VERIFY'
LastTx54 db        'loading'

LastTxt3 db        'Actual state '                 ; Ŀ 14 + 18 + 12 = 44
LastTxt4 db        '--:--a/---------- ('           ;   
LastTxt5 db        '00% loading)',13,10,'$'        ;   dky mus mt
                                                   ;   stejnou dlku !
LastTxt6 db        'Next loading expected at '     ;   
LastTxt7 db        '--:--a             '           ;    26 + 18 = 44
         db        13,10,'$'                       ;   
                                                   ;   
LastTx72 db        'Setting new actual time '      ;    24 + 20 = 44
         db        'and date ....       '          ;   
         db        13,10,'$'                       ; 


LastTxt8 db        'Last time actualisation at '
LastTxt9 db        '--:--a',13,10,'Actual time  '
LastTxt0 db        '00:00:00.00a/00-00-0000 $'

LastTxtD db        'Sunday   ',13,10,'$'
         db        'Monday   ',13,10,'$'
         db        'Tuesday  ',13,10,'$'
         db        'Wednesday',13,10,'$'
         db        'Thursday ',13,10,'$'
         db        'Friday   ',13,10,'$'
         db        'Saturday ',13,10,'$'

NeniCOM  db        13,10,'Port COM'
NeniCOM1 db        '1: is not installed in your computer !',13,10,'$'

NeniTxt  db        13,10,'Program can not be removed from memory, it is not installed yet !',13,10,'$'
NelzeTxt db        13,10,'Program can not be removed from memory, you'
         db        13,10,'must first remove programs installed later !',13,10,'$'
DInsTxt  db        13,10,'Program has been removed from memory.',13,10,'$'
InstTxt  db        13,10,'Program has been installed into memory.',13,10,'$'

ComLine  db        128 dup(0)               ; uschovan pkazov dek

Code     ENDS
         END       Start
